# OrSelector

Extends \BaseSelectorContainer

This selector has a collection of other selectors, any of which have to select a file in order for this selector to select it.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Hans Lellelid hans@xmpl.org (Phing)
author | Bruce Atherton bruce@callenish.com (Ant)
package | phing.types.selectors

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## add an "And" selector entry on the selector list

    createAnd()

inherited

## add a contains selector entry on the selector list

    createContains()

inherited

## add a contains selector entry on the selector list

    createContainsRegexp()

inherited

## add an extended selector entry on the selector list

    createCustom()

inherited

## add a selector date entry on the selector list

    createDate()

inherited

## add a depends selector entry on the selector list

    createDepend()

inherited

## add a depth selector entry on the selector list

    createDepth()

inherited

## add a selector filename entry on the selector list

    createFilename()

inherited

## add a majority selector entry on the selector list

    createMajority()

inherited

## add a "None" selector entry on the selector list

    createNone()

inherited

## add a "Not" selector entry on the selector list

    createNot()

inherited

## add an "Or" selector entry on the selector list

    createOr()

inherited

## add a present selector entry on the selector list

    createPresent()

inherited

## add a "Select" selector entry on the selector list

    createSelector()

inherited

## add a selector size entry on the selector list

    createSize()

inherited

## add a type selector entry on the selector list

    createType()

inherited

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Returns any error messages that have been set.

    getError() : string

inherited

### Response

`string`

the error condition

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a copy of the selectors as an array.

    getSelectors(\Project $p) : array

inherited

### Arguments

#### $p

`\Project`

### Response

`array`

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

inherited

### Response

`boolean`

whether any selectors are in this container

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Returns true (the file is selected) if any of the other selectors agree that the file should be selected.

    isSelected(\PhingFile $basedir,  $filename, \PhingFile $file) : boolean

### Arguments

#### $basedir

`\PhingFile`

the base directory the scan is being done from

#### $filename

``

#### $file

`\PhingFile`

a PhingFile object for the filename that the selector can use

### Response

`boolean`

Whether the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## Gives the count of the number of selectors in this container

    selectorCount() : integer

inherited

### Response

`integer`

the number of selectors in this container

## Returns an array for accessing the set of selectors (not a copy).

    selectorElements() : \an

inherited

### Response

`\an`

enumerator that goes through each of the selectors

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Allows all selectors to indicate a setup error. Note that only the first error message is recorded.

    setError(string $msg) : void

inherited

### Arguments

#### $msg

`string`

The error message any BuildException should throw.

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

## Convert the Selectors within this container to a string. This will just be a helper class for the subclasses that put their own name around the contents listed here.

    toString() : string

inherited

### Response

`string`

comma separated list of Selectors contained in this one

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

inherited

throws |

## <p>Subclasses can override this method to provide checking of their state. So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).</p> <p>Implementations should check for incorrect settings and call setError() as necessary.</p>

    verifySettings()

inherited

### Properties

## selectorsList

    selectorsList :

inherited

### Type(s)

``

## errmsg

    errmsg : string

inherited

var |

### Type(s)

`string`

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`